(:
 : Copyright (c) 2014-2015 Jean-Marc Mercier
  : Licensed under the Apache License, Version 2.0 (the "License");
 : you may not use this file except in compliance with the License.
 : You may obtain a copy of the License at
 :
 :     http://www.apache.org/licenses/LICENSE-2.0
 :
 : Unless required by applicable law or agreed to in writing, software
 : distributed under the License is distributed on an "AS IS" BASIS,
 : WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 : See the License for the specific language governing permissions and
 : limitations under the License.
 :)
module namespace idmap = "http://www.crimere.com/idmap";
import module namespace set="http://www.crimere.com/set" at "set.xqm";
declare default function namespace "http://www.crimere.com/idmap";

declare function  idmap()                                                    {fn:error(xs:QName('idmap'),'without id function, please use a classical map instead to avoid useless overhead')};
declare function  idmap($id as function(item()) as xs:anyAtomicType)         {set:set($id)};

declare function  idmap($idmap, $pairs)                                      {
    let $id := getid($idmap) let $map := set:getmap($idmap) return
    set:pair(map:new( ($map,for $pair in $pairs return map:entry($id(set:first($pair)),$pair)) ),$id)
};


declare function  empty         ($idmap as function() as function(*))           {set:empty($idmap)};
declare function  count         ($idmap as function() as function(*))           {set:count($idmap)};
declare function  get           ($idmap as function() as function(*))           {set:get($idmap)};
declare function  get_keys      ($idmap as function() as function(*))           {for $el in get($idmap) return set:first($el)};
declare function  get_values    ($idmap as function() as function(*))           {for $el in get($idmap) return set:second($el)};
declare function  get           ($idmap as function() as function(*),$keys)     {let $map := set:getmap($idmap) return for $id in getid($idmap,$keys) return map:get($map,$id)};
declare function  get_value     ($idmap as function() as function(*),$keys)     {for $pair in get($idmap,$keys) return set:second($pair)};

declare function  contains      ($idmap as function() as function(*),$key as item()) as xs:boolean                  {set:contains($idmap,$key)}; 
declare function  remove        ($idmap as function() as function(*),$keys)                                         {set:remove($idmap,$keys)}; 

declare function  getid         ($idmap as function() as function(*)) as function(item()) as xs:anyAtomicType *     {set:getid($idmap)};
declare function  getid         ($idmap as function() as function(*),$els) as xs:anyAtomicType *                    {set:getid($idmap,$els)};

                                                        
(:----private-----------:)
declare function GetidMapFromAdjacencyList($pairs,$id) {
    set:pair( 
        map:new(
        for $pair in $pairs let $first :=  set:first($pair) let $idfirst :=  $id($first) let $second  :=  set:second($pair) where (fn:not(fn:empty($idfirst)))
        group by $idfirst
        return map:entry($idfirst, set:pair(fn:head($first),set:get(set:set(set:set($id),$second))))),
        $id)
};


